// 
// module  : noot.ch
// language: xbase++
// auteur  : rene nooteboom
// created : april 2006
// updated : 02/09/2006 17:39
// needs   : simcato.prg( or xbToolsIII library ) en noot.prg
//

#define ALARMTONE tone(300,1)
#define ALARMTOON ALARMTONE

#define EOLINE chr(13)+chr(10)
#define CR chr(13)
#define LF chr(10)
#define CRLF CR+LF
#define EOFILE chr(26)
#define SOFTCR Chr(141)

#define CYFERS "0123456789"
#define ALPHABET "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
#define HEXNUMBERS "0123456789ABCDEF"

#define CRT_FONT_NAME "Alaska Crt"

#define TRUE_C -1 // boolean true is -1 (long) in c(++)
#define FALSE_C 0 // boolean false is 0 (long) in c(++)

#xtranslate IS_ARRAY(<foo>) => (valtype(<foo>) == "A")
#xtranslate IS_BLOCK(<foo>) => (valtype(<foo>) == "B")
#xtranslate IS_CHAR(<foo>) => (valtype(<foo>) == "C")
#xtranslate IS_DATA(<foo>) => (<foo> \>= 32 .AND. <foo> \<= 253 )
#xtranslate IS_DATE(<foo>) => (valtype(<foo>) == "D")
#xtranslate IS_DEF(<foo>) => !(type(<foo>) $ "UE" )
#xtranslate IS_DIGIT(<foo>) => isdigit(<foo>)
#xtranslate IS_INT(<foo>) => (<foo> == int(<foo>) )
#xtranslate IS_ASCII(<xval>) => (if(valtype(<xval>)=="N", ;
 <xval> \> 0 .AND. <xval> \< 128,asc(<xval>) \>0 .AND. ;
 asc(<xval>) \< 128))
#xtranslate IS_PRINTABLE(<xval>) => (if(valtype(<xval>)=="N", ;
 <xval> \>=32 .AND. <xval> \<= 126,asc(<xval>) \>=32 .AND. ;
 asc(<xval>) \<= 126))
#xtranslate IS_CONTROLCHAR(<xval>) => (if(valtype(<xval>)=="N", ;
 (<xval> \>=0 .AND. <xval> \<= 31) .OR. <xval> == 127, ;
 (asc(<xval>) \>=0 .AND. asc(<xval>) \<= 31) .OR. asc(<xval>)==127))
#xtranslate IS_LOGIC(<foo>) => (valtype(<foo>) == "L")
#xtranslate IS_MEMO(<foo>) => (valtype(<foo>) == "M")
#xtranslate IS_NUM(<foo>) => (valtype(<foo>) == "N")
#xtranslate IS_OBJECT(<foo>) => (valtype(<foo>) == "O")
#xtranslate IS_NIL(<foo>) => (<foo> == NIL)
#xtranslate IS_ELEMENT(<array_>,<xvalue>) =>  ;
 (ascan(<array_>,{|el|el==<xvalue>}) > 0)
#xtranslate IS_CURSOR() => empty(setcursor())

#xtranslate IS_EVEN(<foo>) => ( (<foo> % 2)  == 0 )
#xtranslate IS_ODD(<foo>) => ( (<foo> % 2) != 0 )
#xtranslate IS_BETW(<foo>,<lo>,<hi>) => (<foo> \>= <lo> .AND. ;
 <foo> \<= <hi> )
 
#xtranslate IS_CYFERS(<cstring>) => (if(charrem(CYFERS,<cstring>)=="", ;
 .T.,.F.))
 
#xtranslate IS_HEX(<cstring>) => (if(charrem(HEXNUMBERS,<cstring>)=="", ;
 .T.,.F.))
 
//
//  Convert logical to character
//
#define LTOC(l) if(l,"T","F")
//
//  Convert character to logical
//
#define CTOL(c) if(c $ "TtYyJj",.T.,.F.)

#define MAXXYZ(x,y,z) => max(max(x,y),z)
//
// return a string,date or numeric forced between a minimum and maximum
//
#xtranslate MINIMAX(<var>,<lo>,<hi>) => min(<hi>,max(<var>,<lo>))

//
// ARRAY MANIPULATION
//

//
// return the first empty elementnr in a 1-dimensional array
//
#xtranslate AEMPTY(<foo>) => ascan(<foo>,{|x| empty(x) })
//
// return the last filled elementnr in a one-dimensional array
//
#xtranslate AFULL(<foo>) => eval({ |x| if(x==0,len(<foo>),x-1) }, ;
 ascan(<foo>,{ |y| y == NIL} ) )
//
// return the first uninitialized elementnr in a 1-dimensional array
//
#xtranslate ANIL(<foo>) => ascan(<foo>, {|y| y == NIL} )
//
// cast a variable of any type to an array
//
#xtranslate ARRAYIFY(<foo>) => <foo> := if(valtype(<foo>) != ;
 "A", {<foo>},<foo> )
//
// lookup a key in one array return parallel element in a second
// array if found
//
#xtranslate CASE_OF(<foo>,<a1>,<a2>) => eval({|x| if(x>0,<a2>\[ x \], ;
 "") }, ascan(<a1>,<foo>) )
//
// delete last element of array(ASHRINK) 
//
#define ASHRINK(arr) asize(arr,len(arr)-1)
//
// increment size of array by one (NIL) element
//
#define AGROW(arr) asize(arr,len(arr)+1)
//
// soft search ignoring case
//
#define ASCANISOFT(arr,cvalue) ascan(arr,{|el|upper(el)>=upper(cvalue)})
//
// soft search respecting case
//
#define ASCANSOFT(arr,cvalue) ascan(arr,{|el|el>=cvalue})
//
// exact search ignoring case
//
#define ASCANNOCASE(arr,cvalue) ascan(arr,{|el|upper(el)==upper(cvalue)})
//
// exact search respecting case
//
#define ASCANEXACT(arr,cvalue) ascan(arr,{|el|el==cvalue})
//
#define ARRAY_SKIPPER(i,a) {|n,nSavei|nSavei := i,i := if (n > 0, ;
  Min(Len(a), i + n),Max(1, i + n)),i - nSavei}

//
// return largest element in an 1 dim. array
//
#define AMAX(arr) afind(arr,{|i,j| i > j})
//
// return smallest element in an 1 dim. array
//
#define AMIN(arr) afind(arr,{|i,j| i < j})
//
// return longest element in a 1 dim. array (character strings only)
//
#define AMAXLEN(arr) afind(arr,{|i,j| len(i) > len(j)})

#xtranslate AAVG(<foo>) => (asum(<foo>) / len(<foo>) )

//
// return shortest element in 1dim array
//
#define AMINLEN(arr) afind(arr,{|i,j| len(i) < len(j)})  

//
// einde noot.ch
//