//
// module  : simcato.prg
// language: xbase++
// created : 11/04/2006 21:54
// updated : 17/04/2006 11:43
// comment : replacement functions for catools library functions
//           in case the xbtoolsIII (catools) lib is not used

//
// FUNCTION ascpos(cstring,npos) RETURN nasciivalue
// FUNCTION center(cstring,nlen,cpadkar,lmode) RETURN ccenteredstring
// Function charmirr(cstring,lblank) RETURN cmirrored
// Function charone(cdelete,cstring) RETURN cuniquestring
// Function charonly(ckeep,cstring) RETURN cfilteredstring
// Function charrem(cdel_char,cstring) RETURN cfilteredstring
// Function charsort(cstring,nelem_len) RETURN csortedcharacters
// Function numtoken(cstring,cdelimiters,nskipwidth) RETURN nnumberoftokens
// FUNCTION token(cstring,cdelimiters,nnumber,nskipwidth) RETURN ctoken
//

#include "common.ch"
#include "noot.ch"

FUNCTION token(cstring,cdelimiters,nnumber,nskipwidth)
 LOCAL i,ctoken:="",ntoken:=1,ckar
 DEFAULT cdelimiters TO chr(32)+chr(0)+chr(9)+CR+LF+EOFILE+chr(138)+ ;
  SOFTCR+",.;:!?/\()^#&%+-*"
 DEFAULT nnumber TO 1
 FOR i:=1 TO len(cstring)
  ckar := substr(cstring,i,1)
  IF !(ckar $ cdelimiters)
   ctoken += ckar
  ELSE
   ntoken++
   IF ntoken > nnumber
    EXIT
   ELSE
    ctoken := ""
   ENDIF
  ENDIF
 NEXT i
 IF ntoken < nnumber
  ctoken := ""
 ENDIF
 RETURN ctoken
 
Function numtoken(cstring,cdelimiters,nskipwidth)
 LOCAL i,ntokens:=1
 DEFAULT cdelimiters TO chr(32)+chr(0)+chr(9)+CR+LF+EOFILE+chr(138)+ ;
  SOFTCR+",.;:!?/\()^#&%+-*"
 FOR i:=1 TO len(cstring)
  IF substr(cstring,i,1) $ cdelimiters
   ntokens++
  ENDIF
 NEXT i
 RETURN ntokens
 
Function charmirr(cstring,lblank)
 LOCAL cmirrored:="",i
 FOR i:=1 TO len(cstring)
  cmirrored := substr(cstring,i,1) + cmirrored
 NEXT i
 RETURN cmirrored
 
Function charrem(cdel_char,cstring)
 LOCAL cnewstring:="",i
 FOR i:=1 TO len(cstring)
  IF !(substr(cstring,i,1) $ cdel_char)
   cnewstring += substr(cstring,i,1)
  ENDIF
 NEXT i
 RETURN cnewstring
 
Function charonly(ckeep,cstring)
 LOCAL i,cnewstring:=""
 FOR i:=1 TO len(cstring)
  IF substr(cstring,i,1) $ ckeep
   cnewstring += substr(cstring,i,1)
  ENDIF
 NEXT i
 RETURN cnewstring
 
Function charsort(cstring,nelem_len)
 LOCAL carray_:={},i,nr_ofelem,cnewstring
 DEFAULT nelem_len TO 1
 nr_ofelem := int(len(cstring)/nelem_len)
 FOR i:=1 TO nr_ofelem
  aadd(carray_,substr(cstring,(1+((i-1)*nelem_len)),nelem_len))
 NEXT i
 asort(carray_)
 cnewstring := atos(carray_)
 RETURN cnewstring
 
Function charone(cdelete,cstring)
 LOCAL cnewstring:="",i,clast:="",ckar
 FOR i:=1 TO len(cstring)
  ckar := substr(cstring,i,1)
  IF IS_NIL(cdelete) .OR. ckar $ cdelete
   IF !(clast == ckar)
    cnewstring += ckar
   ENDIF
  ELSE
   cnewstring += ckar
  ENDIF
  clast := ckar
 NEXT i
 RETURN cnewstring
 
FUNCTION center(cstring,nlen,cpadkar,lmode)
 LOCAL cnewstring,nleftover
 DEFAULT nlen TO maxcol()+1,cpadkar TO space(1)
 cstring := alltrim(cstring)
 nleftover := int((nlen - len(cstring))/2)
 cnewstring := replicate(cpadkar,nleftover) + cstring
 cnewstring += replicate(cpadkar,nlen-len(cnewstring))
 RETURN cnewstring
 
FUNCTION ascpos(cstring,npos)
 DEFAULT npos TO 1
 RETURN (asc(substr(cstring,npos,1)))

//
// einde simcato.prg
//
 